<template>
  <div>
    <treePage title="菜单列表" @on-result-change="_refresh">
      <template slot="tree">
        <relResourceTree ref="treeModal" @on-result-change="_treeData" />
      </template>
      <template slot="cont">
        <el-row>
          <!--查询-->
          <el-col :span="24" >
            <Form
              v-show="searchOpen"
              onsubmit="return false"
              :label-width="60"
              inline
            >
              <label class="label-sign" />
              <Form-item class="search-item" label="名称:">
                <el-input v-model="formObj.name" placeholder="请输入名称" clearable @keyup.enter.native="_formSearch" />
              </Form-item>
              <Form-item class="search-item" label="系统:">
                <selectSystem @on-result-change="_systemResult"/>
              </Form-item>
              <Form-item class="search-item" label="状态:">
                <el-select v-model="formObj.status" placeholder="请选择状态" style="width: 100%" clearable>
                  <el-option
                    v-for="item in statusList"
                    :key="item.value"
                    :label="item.name"
                    :value="item.value">
                  </el-option>
                </el-select>
              </Form-item>
              <Form-item class="search-btn">
                <el-button type="primary" @click="_formSearch">
                  搜索
                </el-button>
              </Form-item>
            </Form>
          </el-col>
          <!--按钮-->
          <el-col :span="24" >
            <btn-list :msg="btn" :open="searchOpen" show-search-btn="true" @on-result-change="_btnClick" />
          </el-col>
          <!--table-->
          <el-col :span="24" >
            <element-table
              ref="pageTable"
              :page-columns="pageColumns"
              :table-height="tableHeight"
              :get-page="getPage"
              :icon-msg="iconMsg"
              :opt-col-width="70"
              @on-result-change="_tableResultChange"
            >
              <el-table-column
                v-for="item in pageColumns"
                :key="item.key"
                show-overflow-tooltip
                sortable
                :prop="item.key"
                :label="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
              >
                <template slot-scope="scope">
                  <a v-if="item.detail" @click.stop="_detailModal(scope.row.id)">
                    {{ scope.row[item.key] }}
                  </a>
                  <div v-else-if="item.key==='icon'">
                    <i class="iconfont" :class="scope.row[item.key]" ></i> {{ scope.row[item.key] }}
                  </div>
                  <div v-else-if="item.key==='type'">
                    <div v-if="scope.row[item.key]===0" class="green-color">
                      PC菜单
                    </div>
                    <div v-else-if="scope.row[item.key]===2" class="blue-color">
                      APP菜单
                    </div>
                    <div v-else class="warning-color">
                      按钮
                    </div>
                  </div>
                  <div v-else-if="item.key==='status'">
                    <div v-if="scope.row[item.key]===0" class="red-color">
                      禁用
                    </div>
                    <div v-else class="blue-color">
                      正常
                    </div>
                  </div>
                  <div v-else>
                    {{ scope.row[item.key] }}
                  </div>
                </template>
              </el-table-column>
            </element-table>
          </el-col>
        </el-row>
      </template>
    </treePage>
    <!--添加编辑-->
    <resourceEdit ref="editModal" @on-result-change="_search" />
    <!--详情-->
    <resourceDetail ref="detailModal" />
  </div>
</template>
<script>
import { sysResource } from '../../../api'
import treePage from '../../../components/base/treePage'
import selectSystem from '../../../components/base/selectSystem'
import relResourceTree from './tree/relResourceTree'
import resourceDetail from './resourceDetail'
import resourceEdit from './resourceEdit'
export default {
  components: {
    treePage,
    relResourceTree,
    selectSystem,
    resourceDetail,
    resourceEdit
  },
  data() {
    return {
      searchOpen: false,
      btn: [{ type: 'success', id: 'sys-resource-add', name: '添加' }],
      iconMsg: [{ type: 'pt-edit', id: 'sys-resource-edit', name: '编辑' }],
      pageColumns: [
        { title: '名称', key: 'name', width: 120, detail: true, fixed: true },
        { title: '路径', key: 'uri', width: 270 },
        { title: '编码', key: 'code', width: 100 },
        { title: '上级菜单', key: 'parentName', width: 120 },
        { title: '图标', key: 'icon', width: 120 },
        { title: '类型', key: 'type', width: 80 },
        { title: '状态', key: 'status', width: 80 },
        { title: '排序', key: 'sort', width: 100 },
        { title: '备注', key: 'remark' }
      ],
      formObj: {
        id: '',
        name: '',
        status: '',
        systemId: ''
      },
      getPage: {},
      statusList: [
        {
          value: '0',
          name: '禁用'
        },
        {
          value: '1',
          name: '正常'
        }
      ],
      treeObj: {}
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._search()
  },
  methods: {
    // 选择系统返回值
    _systemResult(data) {
      this.formObj.systemId = data
    },
    // 刷新
    _refresh() {
      this.formObj.id = ''
      this.treeObj = {}
      this._formSearch()
    },
    _search() {
      this._formSearch()
      this.$refs.treeModal._open()
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await sysResource.page(this.$serializeForm(this.formObj))
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open(this.treeObj, '')
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data)
          break
      }
    },
    _editModal: async function(data) {
      const result = await sysResource.getById(data.id)
      this.$refs.editModal._open('', result)
    },
    // 详情
    _detailModal(id) {
      this.$refs.detailModal._open(id)
    },
    _treeData(data) {
      this.formObj.id = data.id
      this.treeObj = data
      this._formSearch()
    }
  }
}
</script>
